do
	if( luup.version_major==0 and luup.version_minor<870 ) then
		luup.log("L_sPhoneUI needs version 870 instead of version: " .. tostring(luup.version_branch) .. "." .. tostring(luup.version_major) .. "." .. tostring(luup.version_minor),1)
		lug_sPhoneTask = luup.task("Upgrade your software",2,"Smartphone UI",-1)
		return
	end
	
	sPh_LAYOUT_PFX = 'https://download1.mios.com/L_sPhoneUI_layout'
	g_is_remote = 0

	function string:template(variables)
		return (self:gsub('{%%(.-)%%}', function (key) return tostring(variables[key] or _G[key] or '') end))
	end
	
	function flag(v)
		if( v==nil or tonumber(v)==0 ) then
			return '0'
		end
		return '1'
	end

	luup.register_handler("lug_sPhoneRequest","sPhone")
	luup.register_handler("lug_sPhoneRequest_room","sPhone_room")
	luup.register_handler("lug_sPhoneRequest_action","sPhone_action")
	luup.register_handler("lug_sPhoneRequest_job","sPhone_job")
	luup.register_handler("lug_sPhoneRequest_job_status","sPhone_job_status")
	luup.register_handler("lug_sPhoneRequest_camimg","sPhone_camimg")
	luup.register_handler("lug_sPhoneRequest_action_js","sPhone_action_js")

	luup.log (("L_sPhoneUI running version: {%version_branch%}.{%version_major%}.{%version_minor%}"):template(luup))

	local html_header = ([[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<title>Vera Mobile</title>
		<meta http-equiv="pragma" content="nocache"/>
		<meta name="viewport" content="width=device-width; initial-scale=1.0; maximum-scale=1.0;"/>
		<script src="{%sPh_LAYOUT_PFX%}/js/mobile.js" language="javascript"></script>
		<link rel="stylesheet" href="{%sPh_LAYOUT_PFX%}/css/iui.css" type="text/css" />
	</head>
	<body onLoad="js_prepare_urls();set_layout_prefix('{%sPh_LAYOUT_PFX%}');">
]]):template ({})

	local html_footer=[[
	</body>
</html>]]

	function list_devices (lul_room, out, lul_js)
	
		local grouphead_inserted = false
		
		for k,v in pairs(luup.devices) do
			if( v.room_num==tonumber(lul_room) and v.hidden==false and v.invisible==false ) then
				if not grouphead_inserted then
					table.insert (out,'<li class="group">Devices</li>\n')
					grouphead_inserted = true;
				end
				
				if( v.category_num==2 or v.category_num==8 ) then -- DEVICE_CATEGORY_DIMMABLE_LIGHT
					table.insert (out, '<li class="bg">' .. lug_sPhoneRequest_light(k,v.description,lul_js) .. "</li>\n")
				elseif( v.category_num==5 ) then -- DEVICE_CATEGORY_HVAC
					table.insert (out, '<li class="bg">' .. lug_sPhoneRequest_thermostat(k,v.description,lul_js) .. "</li>\n")
				elseif( v.category_num==7 ) then -- DEVICE_CATEGORY_DOOR_LOCK
					table.insert (out, '<li class="bg">' .. lug_sPhoneRequest_lock(k,v.description,lul_js) .. "</li>\n")
				elseif( v.category_num==6 ) then -- DEVICE_CATEGORY_CAMERA
					table.insert (out, '<li class="bg">' .. lug_sPhoneRequest_camera(k,v.description,lul_js) .. "</li>\n")
				elseif( v.category_num==17 ) then -- DEVICE_CATEGORY_TEMPERATURE
					table.insert (out, '<li class="bg">' .. lug_sPhoneRequest_temp(k,v.description,lul_js) .. "</li>\n")
				elseif( v.category_num==16 ) then -- DEVICE_CATEGORY_HUMIDITY
					table.insert (out, '<li class="bg">' .. lug_sPhoneRequest_humid(k,v.description,lul_js) .. "</li>\n")
				elseif( v.category_num==18 ) then -- DEVICE_CATEGORY_LIGHT
					table.insert (out, '<li class="bg">' .. lug_sPhoneRequest_bright(k,v.description,lul_js) .. "</li>\n")
				elseif( v.category_num==4 or v.category_num==9) then -- DEVICE_CATEGORY_SENSOR, DEVICE_CATEGORY_REMOTE_CONTROL
					table.insert (out, '<li class="bg">' .. lug_sPhoneRequest_sensor(k,v.description,lul_js) .. "</li>\n")
				elseif( v.category_num~=10 and v.category_num~=13 and v.category_num~=1 and v.category_num~=14) then -- DEVICE_CATEGORY_IR_TX, DEVICE_CATEGORY_SERIAL_PORT, DEVICE_CATEGORY_INTERFACE,DEVICE_CATEGORY_SCENE_CONTROLLER
					table.insert (out, '<li class="bg">' .. lug_sPhoneRequest_switch(k,v.description,lul_js) .. "</li>\n")
				end
			end
		end
	end

	function lug_sPhoneRequest(lul_request,lul_parameters,lul_outputformat)
		local lul_js = flag(lul_parameters.js)
		g_is_remote = flag (lul_parameters.r)
-- 		if( lul_js==nil or tonumber(lul_js)==0 ) then
-- 			lul_js = 0
-- 		end
		luup.log("lul_js = " .. lul_js)
		local out = {html_header, [[
		<div id="toolbar" class="toolbar"><!--logout_btn--></div>
		<ul id="searches" title="MyHome" selected="true">
]]}
		local time = os.clock()

		local scene_grouphead_inserted = false
		for k,v in pairs(luup.scenes) do
			if( v.room_num==0 and v.hidden==false ) then
				if not scene_grouphead_inserted then
					table.insert (out, '<li class="group">Scenes</li>')
					scene_grouphead_inserted = true
				end
				table.insert (out, ([[
					<li class="bg">
						<a href="data_request?id=lr_sPhone_action&remote={%remote%}&page={%page%}&room={%room%}&device=0&service=urn:micasaverde-com:serviceId:HomeAutomationGateway1&action=RunScene&SceneNum={%scene_num%}&time={%time%}">
							<img src="{%sPh_LAYOUT_PFX%}/buttons/go.gif" alt="" width="36" height="36" border="0" align="absmiddle" class="icon"/>
						</a>
						{%description%}
					</li>
				]]):template {
					remote = v.remote,
					page = v.page,
					description = v.description,
					room = 0,
					scene_num = k,
					time = time,
				})
			end
		end

		if next(luup.rooms) ~= nil then
			table.insert (out, '<li class="group">My Home</li>')
		end

		for k,v in pairs(luup.rooms) do
			table.insert (out, ([[
				<li><a class="pic" href="data_request?id=lr_sPhone_room&room={%room%}&time={%time%}">
					{%room_name%}
				</a></li>
			]]):template {
				room = k,
				room_name = v,
				time = time,
			})
		end
		
		list_devices (0, out, lul_js)
		
		table.insert (out, '</ul>')
		table.insert (out, html_footer)

		return table.concat (out),"text/html"
	end

	function lug_sPhoneRequest_action(lul_request,lul_parameters,lul_outputformat)
		local lul_remote = lul_parameters.remote
		local lul_page = lul_parameters.page
		local lul_room = lul_parameters.room or 0
		local lul_device = lul_parameters.device or 0
		local lul_action = lul_parameters.action
		local lul_service = lul_parameters.service
		local html_header_action = ''

		if( lul_remote~=nil and tonumber(lul_remote)>0 ) then
			html_header_action = ([[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<title>Vera Mobile</title>
	<meta http-equiv="pragma" content="nocache"/>
	<meta name="viewport" content="width=device-width; initial-scale=1.0; maximum-scale=1.0;"/>
	<meta http-equiv="refresh" content="0;url="/port_3480/luvd/PK_Remote_{%lul_remote%}_{%lul_page%}.html" />
	<script src="{%sPh_LAYOUT_PFX%}/js/mobile.js" language="javascript"></script>
	<link rel="stylesheet" href="{%sPh_LAYOUT_PFX%}/css/iui.css" type="text/css" />
</head>
<body onLoad="js_prepare_urls();">
			]]):template {
				lul_remote = lul_remote,
				lul_page,
			}
		else
			html_header_action = html_header
		end

		lul_device = tonumber(lul_device)
		if( lul_device==nil or lul_action==nil or lul_service==nil ) then
			luup.log("lug_sPhoneRequest_action: missing arguments")
			return (html_header .. [[
				<div>
					<img src="{%sPh_LAYOUT_PFX%}/buttons/eror.gif" alt="" border="0" class="icon" align="absmiddle"/>
					Internal Error: Missing arguments
				</div>
			]] .. html_footer)
		end
		if lul_room == 0 and lul_device ~= 0 then
			lul_room = luup.devices[lul_device].room_num
		end
		
		if lul_device ~= 0 and luup.devices[lul_device]==nil then
			luup.log (("lug_sPhoneRequest_action: invalid device (%s)"):format(lul_device))
			return (html_header .. [[
				<div>
					<img src="{%sPh_LAYOUT_PFX%}/buttons/eror.gif" alt="" border="0" class="icon" align="absmiddle"/>
					Internal Error: Invalid Device
				</div>
			]] .. html_footer)
		end

		local lul_arguments = {}

		for k,v in pairs(lul_parameters) do
			if( k~="device" and k~="action" and k~="service" and k~="room" and k~="time" ) then
				lul_arguments[k]=v
			end

			luup.log(("lug_sPhoneRequest_action: %s=%s"):format(tostring(k),v))
		end

		for k,v in pairs(lul_arguments ) do
			luup.log(("lug_sPhoneRequest_action: argument %s=%s"):format (tostring(k), v))
		end

		local lul_resultcode,lul_resultstring,lul_job,lul_returnarguments = luup.call_action(lul_service,lul_action,lul_arguments,tonumber(lul_device))

		luup.log (("lug_sPhoneRequest_action: device: {%device%} action: {%action%} service {%service%} returned: {%resultcode%} str {%resultstring%} job {%job%}"):template {
			device = lul_device,
			action = lul_action,
			service = lul_service,
			resultcode = lul_resultcode,
			resultstring = lul_resultstring,
			job = lul_job
		})

		if( lul_resultcode~=0 ) then
			return ([[
				{%html_header%}
				<div>
					<img src="{%sPh_LAYOUT_PFX%}/buttons/eror.gif" alt="" border="0" class="icon" align="absmiddle"/>
					Error: {%lul_resultcode%}: {%lul_resultstring%}<br>
					<a href="data_request?id=lr_sPhone_room&room={%room_num%}&time={%time%}">OK - back</a><br>
				</div>
				{%html_footer%}
			]]):template {
				html_header = html_header,
				html_footer = html_footer,
				lul_resultcode = lul_resultcode,
				lul_resultstring = lul_resultstring,
				room_num = lul_room, --luup.devices[lul_device].room_num,
				time = os.clock(),
			}
		end

		if ( lul_job==0 ) then
			return ([[
				{%html_header_action%}
				<div id="toolbar" class="toolbar">
					<a href="data_request?id=lr_sPhone_room&room={%room%}&time={%time%}">
						<img src="{%sPh_LAYOUT_PFX%}/images/backButton.gif" border="0">
					</a>
				</div>
				<div>
					<img src="{%sPh_LAYOUT_PFX%}/buttons/ok.gif" alt="" border="0" class="icon" align="absmiddle"/>
					Command executed OK<br>
				</div>
				{%html_footer%}
			]]):template {
				html_header_action = html_header_action,
				html_footer = html_footer,
				room = lul_room,
				time = os.clock(),
			}
		end

		return ([[
			{%html_header_action%}
			<div id="toolbar" class="toolbar">
				<a href="data_request?id=lr_sPhone_room&room={%room%}&time={%time%}">
					<img src="{%sPh_LAYOUT_PFX%}/images/backButton.gif" border="0">
				</a>
			</div>
			<div>
				<img src="{%sPh_LAYOUT_PFX%}/buttons/wait.gif" alt="" border="0" class="icon" align="absmiddle"/>
				Running command now...<br>
				<a href="data_request?id=lr_sPhone_job&device={%device%}&room={%room%}&job={%job%}&time={%time%}">
					Check the status
				</a>
			</div>
			{%html_footer%}
		]]):template {
			html_header_action = html_header_action,
			html_footer = html_footer,
			room = lul_room, --luup.devices[lul_device].room_num,
			time = os.clock(),
			device = lul_device,
			job = lul_job,
		}
	end

	function lug_sPhoneRequest_camera(lul_device,lul_description,lul_js)
		return ([[
			<img src="{%sPh_LAYOUT_PFX%}/icons/camera.gif" alt="" width="44" height="43" align="absmiddle" class="icon"/>
				{%description%} <br>
			<a href="data_request?id=lr_sPhone_camimg&device={%device%}&time={%time%}&js={%js%}&r={%g_is_remote%}">
				<img src="{%sPh_LAYOUT_PFX%}/buttons/view.gif" alt="" border="0"/>
			</a>
		]]):template {
			description = lul_description,
			device = lul_device,
			time = os.clock(),
			js = lul_js,
		}
	end


	function lug_sPhoneRequest_job(lul_request,lul_parameters,lul_outputformat)
		local lul_device = lul_parameters.device
		local lul_room = lul_parameters.room
		local lul_job = lul_parameters.job

		local lul_job_status,lul_job_text = luup.job.status(lul_job,tonumber(lul_device))

		local lul_text = ""

		if( lul_job_status==nil ) then
			lul_text = [[
				<img src="{%sPh_LAYOUT_PFX%}/buttons/eror.gif" alt="" border="0" class="icon" align="absmiddle"/>
				No information on command.<br>
				Command history is only kept for 30 seconds.
			]]
		elseif( lul_job_status==0 or lul_job_status==1 or lul_job_status==5 ) then
			lul_text = ([[
				<img src="{%sPh_LAYOUT_PFX%}/buttons/wait.gif" alt="" border="0" class="icon" align="absmiddle"/>
				Command is still running...<br>
				<a href="data_request?id=lr_sPhone_job&device={%device%}&room={%room%}&job={%job%}&time={%time%}">Refresh</a>'
			]]):template {
				device = lul_device,
				room = lul_room,
				job = lul_job,
				time = os.clock(),
			}
		elseif( lul_job_status==2 or lul_job_status==3 ) then
			lul_text = [[
				<img src="{%sPh_LAYOUT_PFX%}/buttons/eror.gif" alt="" border="0" class="icon" align="absmiddle"/>
				Failed to run command
			]]
		elseif( lul_job_status==4 ) then
			lul_text = [[
				<img src="{%sPh_LAYOUT_PFX%}/buttons/ok.gif" alt="" border="0" class="icon" align="absmiddle"/>
				Command completed ok
			]]
		else
			lul_text = [[
				<img src="{%sPh_LAYOUT_PFX%}/buttons/eror.gif" alt="" border="0" class="icon" align="absmiddle"/>
				Unknown status:]] .. tostring(lul_job_status)
		end

		return ([[
			{%html_header%}
			<div id="toolbar" class="toolbar">
				<a href="data_request?id=lr_sPhone_room&room={%room%}&time={%time%}">
					<img src="{%sPh_LAYOUT_PFX%}/images/backButton.gif" border="0">
				</a>
			</div>
			<div>
				{%text%}
			</div>
			{%html_footer%}
		]]):template {
			html_header = html_header,
			html_footer = html_footer,
			room = lul_room,
			time = os.clock(),
			text = lul_text,
		}
	end

	function lug_sPhoneRequest_light(lul_device,lul_description,lul_js)
		local lul_Status = luup.variable_get("urn:upnp-org:serviceId:SwitchPower1","Status",lul_device)
		local lul_Level = luup.variable_get("urn:upnp-org:serviceId:Dimming1","LoadLevelStatus",lul_device) or '0'
		local levelnum = tonumber(lul_Level)
		
		luup.log (string.format ('device [%s] light level [%s]', lul_device, lul_Level))

		local tmpl_params =  {
			description = lul_description,
			room = luup.devices[tonumber(lul_device) or 1].room_num,
			device = lul_device,
			time = os.clock(),
			level = lul_Level,
			status_0 = lul_Level=='0' and '_h' or '',
			status_25 = (levelnum>=12.5) and '_h' or '',
			status_50 = (levelnum>=37.5) and '_h' or '',
			status_75 = (levelnum>=62.5) and '_h' or '',
			status_100 = (levelnum>=87.5) and '_h' or '',
		}

		if( lul_js=='1' ) then
			return ([[
				<img src="{%sPh_LAYOUT_PFX%}/icons/dimmable.gif" alt="" width="44" height="43" align="absmiddle" class="icon"/>{%description%}<br/>
				<img src="{%sPh_LAYOUT_PFX%}/images/spacer.gif" border="0" width="20" height="20" id="action_icon_{%device%}">
				<a href="javascript:void(0);" onClick="set_device_icon({%device%},1);send_command('data_request?id=lr_sPhone_action_js&room={%room%}&device={%device%}&service=urn:upnp-org:serviceId:SwitchPower1&action=SetTarget&newTargetValue=0&time={%time%}',{%device%})"><img src="{%sPh_LAYOUT_PFX%}/buttons/off{%status_0%}.gif" alt="" border="0"/></a>
				<a href="javascript:void(0);" onClick="set_device_icon({%device%},1);send_command('data_request?id=lr_sPhone_action_js&room={%room%}&device={%device%}&service=urn:upnp-org:serviceId:Dimming1&action=SetLoadLevelTarget&newLoadlevelTarget=25&time={%time%}',{%device%})"><img src="{%sPh_LAYOUT_PFX%}/buttons/25{%status_25%}.gif" alt="" border="0"/></a>
				<a href="javascript:void(0);" onClick="set_device_icon({%device%},1);send_command('data_request?id=lr_sPhone_action_js&room={%room%}&device={%device%}&service=urn:upnp-org:serviceId:Dimming1&action=SetLoadLevelTarget&newLoadlevelTarget=50&time={%time%}',{%device%})"><img src="{%sPh_LAYOUT_PFX%}/buttons/50{%status_50%}.gif" alt="" border="0"/></a>
				<a href="javascript:void(0);" onClick="set_device_icon({%device%},1);send_command('data_request?id=lr_sPhone_action_js&room={%room%}&device={%device%}&service=urn:upnp-org:serviceId:Dimming1&action=SetLoadLevelTarget&newLoadlevelTarget=75&time={%time%}',{%device%})"><img src="{%sPh_LAYOUT_PFX%}/buttons/75{%status_75%}.gif" alt="" border="0"/></a>
				<a href="javascript:void(0);" onClick="set_device_icon({%device%},1);send_command('data_request?id=lr_sPhone_action_js&room={%room%}&device={%device%}&service=urn:upnp-org:serviceId:SwitchPower1&action=SetTarget&newTargetValue=1&time={%time%}',{%device%})"><img src="{%sPh_LAYOUT_PFX%}/buttons/on{%status_100%}.gif" alt="" border="0"/></a> ({%level%})
			]]):template (tmpl_params)
		else
			return ([[<img src="{%sPh_LAYOUT_PFX%}/icons/dimmable.gif" alt="" width="44" height="43" align="absmiddle" class="icon"/>{%description%}<br/>
				<a href="data_request?id=lr_sPhone_action&room={%room%}&device={%device%}&service=urn:upnp-org:serviceId:SwitchPower1&action=SetTarget&newTargetValue=0&time={%time%}"><img src="{%sPh_LAYOUT_PFX%}/buttons/off{%status_0%}.gif" alt="" border="0"/></a>
				<a href="data_request?id=lr_sPhone_action&room={%room%}&device={%device%}&service=urn:upnp-org:serviceId:Dimming1&action=SetLoadLevelTarget&newLoadlevelTarget=25&time={%time%}"><img src="{%sPh_LAYOUT_PFX%}/buttons/25{%status_25%}.gif" alt="" border="0"/></a>
				<a href="data_request?id=lr_sPhone_action&room={%room%}&device={%device%}&service=urn:upnp-org:serviceId:Dimming1&action=SetLoadLevelTarget&newLoadlevelTarget=50&time={%time%}"><img src="{%sPh_LAYOUT_PFX%}/buttons/50{%status_50%}.gif" alt="" border="0"/></a>
				<a href="data_request?id=lr_sPhone_action&room={%room%}&device={%device%}&service=urn:upnp-org:serviceId:Dimming1&action=SetLoadLevelTarget&newLoadlevelTarget=75&time={%time%}"><img src="{%sPh_LAYOUT_PFX%}/buttons/75{%status_75%}.gif" alt="" border="0"/></a>
				<a href="data_request?id=lr_sPhone_action&room={%room%}&device={%device%}&service=urn:upnp-org:serviceId:SwitchPower1&action=SetTarget&newTargetValue=1&time={%time%}"><img src="{%sPh_LAYOUT_PFX%}/buttons/on{%status_100%}.gif" alt="" border="0"/></a>
			]]):template (tmpl_params)
		end
	end

	function lug_sPhoneRequest_switch(lul_device,lul_description,lul_js)
		local lul_Status = luup.variable_get("urn:upnp-org:serviceId:SwitchPower1","Status",lul_device)

		local tmpl_params = {
			device = lul_device,
			description = lul_description,
			room = luup.devices[tonumber(lul_device)].room_num,
			time = os.clock(),
			status_0 = lul_Status=="0" and '_h' or '',
			status_100 = lul_Status=="1" and '_h' or '',
		}

		if( lul_js=='1' ) then
			return ([[
				<img src="{%sPh_LAYOUT_PFX%}/icons/switch.gif" alt="" width="44" height="43" align="absmiddle" class="icon" id="pic_device_{%device%}" />{%description%}<br>
				<img src="{%sPh_LAYOUT_PFX%}/images/spacer.gif" border="0" width="20" height="20" id="action_icon_{%lul_device%}">
				<a href="javascript:void(0);" onClick="set_device_icon({%device%},1);send_command('data_request?id=lr_sPhone_action_js&room={%room%}&device={%device%}&service=urn:upnp-org:serviceId:SwitchPower1&action=SetTarget&newTargetValue=0&time={%time%}',{%device%})"><img src="{%sPh_LAYOUT_PFX%}/buttons/off{%status_0%}.gif" alt="" border="0"/></a>
				<a href="javascript:void(0);" onClick="set_device_icon({%device%},1);send_command('data_request?id=lr_sPhone_action_js&room={%room%}&device={%device%}&service=urn:upnp-org:serviceId:SwitchPower1&action=SetTarget&newTargetValue=1&time={%time%}',{%device%})"><img src="{%sPh_LAYOUT_PFX%}/buttons/on{%status_100%}.gif" alt="" border="0"/></a>
			]]):template (tmpl_params)
		else
			return ([[
				<img src="{%sPh_LAYOUT_PFX%}/icons/switch.gif" alt="" width="44" height="43" align="absmiddle" class="icon" />{%description%}<br>
				<a href="data_request?id=lr_sPhone_action&room={%room%}&device={%device%}&service=urn:upnp-org:serviceId:SwitchPower1&action=SetTarget&newTargetValue=0&time={%time%}"><img src="{%sPh_LAYOUT_PFX%}/buttons/off{%status_0%}.gif" alt="" border="0"/></a>
				<a href="data_request?id=lr_sPhone_action&room={%room%}&device={%device%}&service=urn:upnp-org:serviceId:SwitchPower1&action=SetTarget&newTargetValue=1&time={%time%}"><img src="{%sPh_LAYOUT_PFX%}/buttons/on{%status_100%}.gif" alt="" border="0"/></a>
			]]):template (tmpl_params)
		end
	end

	function lug_sPhoneRequest_sensor(lul_device,lul_description,lul_js)
		local lul_Armed = luup.variable_get("urn:micasaverde-com:serviceId:SecuritySensor1","Armed",lul_device)
		local lul_Tripped = luup.variable_get("urn:micasaverde-com:serviceId:SecuritySensor1","Tripped",lul_device)
		local lul_Temp = luup.variable_get("urn:upnp-org:serviceId:TemperatureSensor1","CurrentTemperature",lul_device)

		local tmpl_params = {
			device = lul_device,
			description = lul_description,
			time = os.clock(),
			status_tripped = lul_Tripped~="1" and 'green' or 'red',
		}
		if( lul_Armed~="1") then
			tmpl_params.status_arm = ''
			tmpl_params.status_bypass = '_h'
		else
			tmpl_params.status_arm = '_h'
			tmpl_params.status_bypass = ''
		end

		if lul_Temp then
			tmpl_params.temp = string.format("Temperature:%s&deg;", lul_Temp)
		end

		if( lul_js=='1' ) then
			return ([[
				<img src="{%sPh_LAYOUT_PFX%}/icons/security.gif" alt="" width="44" height="43" align="absmiddle" class="icon" id="pic_device_{%device%}" />{%description%}<br>
				<img src="{%sPh_LAYOUT_PFX%}/images/spacer.gif" border="0" width="20" height="20" id="action_icon_{%lul_device%}">
				<a href="javascript:void(0);" onClick="set_device_icon({%device%},1);send_command('data_request?id=lu_variableset&DeviceNum={%device%}&serviceId=urn:micasaverde-com:serviceId:SecuritySensor1&Variable=Tripped&Value=1&time={%time%}',{%device%})"><img src="{%sPh_LAYOUT_PFX%}/images/{%status_tripped%}_circle.gif" alt="" border="0"/></a>
				<a href="javascript:void(0);" onClick="set_device_icon({%device%},1);send_command('data_request?id=lu_variableset&DeviceNum={%device%}&serviceId=urn:micasaverde-com:serviceId:SecuritySensor1&Variable=Armed&Value=1&time={%time%}',{%device%})"><img src="{%sPh_LAYOUT_PFX%}/buttons/arm{%status_arm%}.gif" alt="" border="0"/></a>
				<a href="javascript:void(0);" onClick="set_device_icon({%device%},1);send_command('data_request?id=lu_variableset&DeviceNum={%device%}&serviceId=urn:micasaverde-com:serviceId:SecuritySensor1&Variable=Armed&Value=0&time={%time%}',{%device%})"><img src="{%sPh_LAYOUT_PFX%}/buttons/bypass{%status_bypass%}.gif" alt="" border="0"/></a>
				{%temp%}
			]]):template (tmpl_params)
		else
			return ([[
				<img src="{%sPh_LAYOUT_PFX%}/icons/security.gif" alt="" width="44" height="43" align="absmiddle" class="icon" />{%description%}<br>
				<a href="data_request?id=lu_variableset&DeviceNum={%device%}&serviceId=urn:micasaverde-com:serviceId:SecuritySensor1&Variable=Tripped&time={%time%}"><img src="{%sPh_LAYOUT_PFX%}/images/{%status_tripped%}_circle.gif" alt="" border="0"/></a>
				<a href="data_request?id=lu_variableset&DeviceNum={%device%}&serviceId=urn:micasaverde-com:serviceId:SecuritySensor1&Variable=Armed&Value=1&time={%time%}"><img src="{%sPh_LAYOUT_PFX%}/buttons/arm{%status_arm%}.gif" alt="" border="0"/></a>
				<a href="data_request?id=lu_variableset&DeviceNum={%device%}&serviceId=urn:micasaverde-com:serviceId:SecuritySensor1&Variable=Armed&Value=0&time={%time%}"><img src="{%sPh_LAYOUT_PFX%}/buttons/bypass{%status_bypass%}.gif" alt="" border="0"/></a>
				{%temp%}
			]]):template (tmpl_params)
		end
	end

	function lug_sPhoneRequest_temp(lul_device,lul_description,lul_js)
		local lul_Temp = luup.variable_get("urn:upnp-org:serviceId:TemperatureSensor1","CurrentTemperature",lul_device)
		local tmpl_params = {
			device = lul_device,
			description = lul_description,
			temp = lul_Temp or 'N/A',
		}

		if( lul_js=='1' ) then
			return ([[
				<img src="{%sPh_LAYOUT_PFX%}/icons/thermostat.gif" alt="" width="44" height="43" align="absmiddle" class="icon" id="pic_device_{%device%}" />{%description%}<br>
				<img src="{%sPh_LAYOUT_PFX%}/images/spacer.gif" border="0" width="20" height="20" id="action_icon_{%device%}">
				Temperature: {%temp%}&deg;<br/>
			]]):template (tmpl_params)
		else
			return ([[
				<img src="{%sPh_LAYOUT_PFX%}/icons/thermostat.gif" alt="" width="44" height="43" align="absmiddle" class="icon" />{%description%}<br>
				Temperature: {%temp%}&deg;<br/>
			]]):template (tmpl_params)
		end
	end
	
	function lug_sPhoneRequest_humid(lul_device, lul_description, lul_js)
		local lul_humid = luup.variable_get ('urn:micasaverde-com:serviceId:HumiditySensor1', 'CurrentLevel', lul_device)
		local tmpl_params = {
			device = lul_device,
			description = lul_description,
			humid = lul_humid or 'N/A',
		}
		
		if (lul_js=='1') then
			return ([[
				<img src="{%sPh_LAYOUT_PFX%}/icons/thermostat.gif" alt="" width="44" height="43" align="absmiddle" class="icon" id="pic_device_{%device%}" />{%description%}<br>
				<img src="{%sPh_LAYOUT_PFX%}/images/spacer.gif" border="0" width="20" height="20" id="action_icon_{%device%}">
				Humidity: {%humid%}%<br/>
			]]):template (tmpl_params)
		else
			return ([[
				<img src="{%sPh_LAYOUT_PFX%}/icons/thermostat.gif" alt="" width="44" height="43" align="absmiddle" class="icon" />{%description%}<br>
				Humidity: {%humid%}%<br/>
			]]):template (tmpl_params)
		end
	end

	function lug_sPhoneRequest_bright(lul_device,lul_description,lul_js)
		local lul_Level = luup.variable_get("urn:micasaverde-com:serviceId:LightSensor1","CurrentLevel",lul_device)
		local tmpl_params = {
			device = lul_device,
			description = lul_description,
			level = lul_Level or 'N/A',
		}

		if( lul_js=='1' ) then
			return ([[
				<img src="{%sPh_LAYOUT_PFX%}/icons/brightness.gif" alt="" width="44" height="43" align="absmiddle" class="icon" id="pic_device_{%device%}" />{%description%}<br>
				<img src="{%sPh_LAYOUT_PFX%}/images/spacer.gif" border="0" width="20" height="20" id="action_icon_{%device%}">
				Light level: {%level%}%<br/>
			]]):template(tmpl_params)
		else
			return ([[
				<img src="{%sPh_LAYOUT_PFX%}/icons/brightness.gif" alt="" width="44" height="43" align="absmiddle" class="icon" />{%description%}<br>
				Light level: {%level%}%<br/>
			]]):template(tmpl_params)
		end
	end

	function lug_sPhoneRequest_thermostat(lul_device,lul_description,lul_js)
		local lul_Status = luup.variable_get("urn:upnp-org:serviceId:HVAC_UserOperatingMode1","ModeStatus",lul_device)
		local lul_fan_status = luup.variable_get("urn:upnp-org:serviceId:HVAC_FanOperatingMode1","ModeStatus",lul_device)

		tmpl_params = {
			description = lul_description,
			device = lul_device,
			room = luup.devices[tonumber(lul_device)].room_num,
			time = os.clock(),
			temp = luup.variable_get("urn:upnp-org:serviceId:TemperatureSensor1","CurrentTemperature",lul_device),
			setPointCool = luup.variable_get("urn:upnp-org:serviceId:TemperatureSetpoint1_Cool","CurrentSetpoint",lul_device),
			setPointHeat = luup.variable_get("urn:upnp-org:serviceId:TemperatureSetpoint1_Heat","CurrentSetpoint",lul_device),
			status_off = lul_Status=='Off' and '_h' or '',
			status_heat = lul_Status=='HeatOn' and '_h' or '',
			status_cool = lul_Status=='CoolOn' and '_h' or '',
			status_auto = lul_Status=="AutoChangeOver" and '_h' or '',
			status_fan_auto = lul_fan_status=='Auto' and '_h' or '',
			status_fan_on = lul_fan_status=='Auto' and '' or '_h',
		}


		if( lul_js=='1' ) then
			return ([[
				<img src="{%sPh_LAYOUT_PFX%}/icons/thermostat.gif" alt="" width="44" height="43" align="absmiddle" class="icon"/>{%description%}<br>
				<img src="{%sPh_LAYOUT_PFX%}/images/spacer.gif" border="0" width="20" height="20" id="action_icon_{%device%}">
				<a href="javascript:void(0);" onClick="set_device_icon({%device%},1);send_command('data_request?id=lr_sPhone_action_js&room={%room%}&device={%device%}&service=urn:upnp-org:serviceId:HVAC_UserOperatingMode1&action=SetModeTarget&NewModeTarget=Off&time={%time%}',{%device%})"><img src="{%sPh_LAYOUT_PFX%}/buttons/off{%status_off%}.gif" alt="" border="0"/></a>
				<a href="javascript:void(0);" onClick="set_device_icon({%device%},1);send_command('data_request?id=lr_sPhone_action_js&room={%room%}&device={%device%}&service=urn:upnp-org:serviceId:HVAC_UserOperatingMode1&action=SetModeTarget&NewModeTarget=CoolOn&time={%time%}',{%device%})"><img src="{%sPh_LAYOUT_PFX%}/buttons/cool{%status_cool%}.gif" alt="" border="0"/></a>
				<a href="javascript:void(0);" onClick="set_device_icon({%device%},1);send_command('data_request?id=lr_sPhone_action_js&room={%room%}&device={%device%}&service=urn:upnp-org:serviceId:HVAC_UserOperatingMode1&action=SetModeTarget&NewModeTarget=HeatOn&time={%time%}',{%device%})"><img src="{%sPh_LAYOUT_PFX%}/buttons/heat{%status_heat%}.gif" alt="" border="0"/></a>
				<a href="javascript:void(0);" onClick="set_device_icon({%device%},1);send_command('data_request?id=lr_sPhone_action_js&room={%room%}&device={%device%}&service=urn:upnp-org:serviceId:HVAC_UserOperatingMode1&action=SetModeTarget&NewModeTarget=AutoChangeOver&time={%time%}',{%device%})"><img src="{%sPh_LAYOUT_PFX%}/buttons/auto{%status_auto%}.gif" alt="" border="0"/></a> <br/>
				Fan: <a href="javascript:void(0);" onClick="set_device_icon('{%device%},1);send_command('data_request?id=lr_sPhone_action_js&room={%room%}&device={%device%}&service=urn:upnp-org:serviceId:HVAC_FanOperatingMode1&action=SetMode&NewMode=Auto&time={%time%}',{%device%})"><img src="{%sPh_LAYOUT_PFX%}/buttons/auto{%status_fan_auto%}.gif" alt="" border="0"/></a>
				<a href="javascript:void(0);" onClick="set_device_icon({%device%},1);send_command('data_request?id=lr_sPhone_action_js&room={%room%}&device={%device%}&service=urn:upnp-org:serviceId:HVAC_FanOperatingMode1&action=SetMode&NewMode=ContinuousOn&time={%time%}',{%device%})"><img src="{%sPh_LAYOUT_PFX%}/buttons/on{%status_fan_on%}.gif" alt="" border="0"/></a><br/>
				<table cellpadding="2" cellspacing="0">
					<tr>
						<td>Heat: </td>
						<td><input type="text" name="NewCurrentSetpoint" id="NewCurrentSetpoint_Heat_{%device%}" value="" size="3"></td>
						<td><img src="{%sPh_LAYOUT_PFX%}/images/set_deasupra.gif" border="0" onClick="set_device_icon({%device%},1);send_command('data_request?id=lr_sPhone_action_js&room={%room%}&device={%device%}&service=urn:upnp-org:serviceId:TemperatureSetpoint1_Heat&action=SetCurrentSetpoint&NewCurrentSetpoint='+document.getElementById('NewCurrentSetpoint_Heat_{%device%}').value+'&time={%time%}',{%device%});" border="0"></td>
					</tr>

					<tr>
						<td>Cool: </td>
						<td><input type="text" name="NewCurrentSetpoint" id="NewCurrentSetpoint_Cool_{%device%}" value="" size="3"></td>
						<td><img src="{%sPh_LAYOUT_PFX%}/images/set_deasupra.gif" border="0" onClick="set_device_icon({%device%},1);send_command('data_request?id=lr_sPhone_action_js&room={%room%}&device={%device%}&service=urn:upnp-org:serviceId:TemperatureSetpoint1_Cool&action=SetCurrentSetpoint&NewCurrentSetpoint='+document.getElementById('NewCurrentSetpoint_Cool_{%device%}').value+'&time={%time%}',{%device%});" border="0"></td>
					</tr>
				</table>
				Current temperature: {%temp%}&deg;<br/>
				Set point heat: {%setPointHeat%}&deg;<br/>
				Set point cool: {%setPointCool%}&deg;
			]]):template (tmpl_params)
		else
			return ([[
				<img src="{%sPh_LAYOUT_PFX%}/icons/thermostat.gif" alt="" width="44" height="43" align="absmiddle" class="icon"/>{%description%}<br>
				<a href="data_request?id=lr_sPhone_action&room={%room%}&device={%device%}&service=urn:upnp-org:serviceId:HVAC_UserOperatingMode1&action=SetModeTarget&NewModeTarget=Off&time={%time%}"><img src="{%sPh_LAYOUT_PFX%}/buttons/off{%status_off%}.gif" alt="" border="0"/></a>
				<a href="data_request?id=lr_sPhone_action&room={%room%}&device={%device%}&service=urn:upnp-org:serviceId:HVAC_UserOperatingMode1&action=SetModeTarget&NewModeTarget=CoolOn&time={%time%}"><img src="{%sPh_LAYOUT_PFX%}/buttons/cool{%status_cool%}.gif" alt="" border="0"/></a>
				<a href="data_request?id=lr_sPhone_action&room={%room%}&device={%device%}&service=urn:upnp-org:serviceId:HVAC_UserOperatingMode1&action=SetModeTarget&NewModeTarget=HeatOn&time={%time%}"><img src="{%sPh_LAYOUT_PFX%}/buttons/heat{%status_heat%}.gif" alt="" border="0"/></a>
				<a href="data_request?id=lr_sPhone_action&room={%room%}&device={%device%}&service=urn:upnp-org:serviceId:HVAC_UserOperatingMode1&action=SetModeTarget&NewModeTarget=AutoChangeOver&time={%time%}"><img src="{%sPh_LAYOUT_PFX%}/buttons/auto{%status_auto%}.gif" alt="" border="0"/></a> <br/>
				Fan: <a href="\data_request?id=lr_sPhone_action&room={%room%}&device={%device%}&service=urn:upnp-org:serviceId:HVAC_FanOperatingMode1&action=SetMode&NewMode=Auto&time={%time%}"><img src="{%sPh_LAYOUT_PFX%}/buttons/auto{%status_fan_auto%}.gif" alt="" border="0"/></a>
				<a href="\data_request?id=lr_sPhone_action&room={%room%}&device={%device%}&service=urn:upnp-org:serviceId:HVAC_FanOperatingMode1&action=SetMode&NewMode=ContinuousOn&time={%time%}"><img src="{%sPh_LAYOUT_PFX%}/buttons/on{%status_fan_on%}.gif" alt="" border="0"/></a><br/>
				<table cellpadding="2" cellspacing="0">
				<form action="\data_request" method="get">
				<input type="hidden" name="id" value="lr_sPhone_action">
				<input type="hidden" name="room" value="{%room%}">
				<input type="hidden" name="device" value="{%device%}">
				<input type="hidden" name="service" value="urn:upnp-org:serviceId:TemperatureSetpoint1_Heat">
				<input type="hidden" name="action" value="SetCurrentSetpoint">
				<input type="hidden" name="time" value="{%time%}">
					<tr>
						<td>Heat: </td>
						<td><input type="text" name="NewCurrentSetpoint" value="" size="3"></td>
						<td><input type="image" src="{%sPh_LAYOUT_PFX%}/images/set_deasupra.gif" border="0"></td>
					</tr>
				</form>
				<form action="\data_request" method="get">
				<input type="hidden" name="id" value="lr_sPhone_action">
				<input type="hidden" name="room" value="{%room%}">
				<input type="hidden" name="device" value="{%device%}">
				<input type="hidden" name="service" value="urn:upnp-org:serviceId:TemperatureSetpoint1_Cool">
				<input type="hidden" name="action" value="SetCurrentSetpoint">
				<input type="hidden" name="time" value="{%time%}">

					<tr>
						<td>Cool: </td>
						<td><input type="text" name="NewCurrentSetpoint" value="" size="3"></td>
						<td><input type="image" src="{%sPh_LAYOUT_PFX%}/images/set_deasupra.gif" border="0"></td>
					</tr>
				</form>
				</table>
				Current temperature: {%temp%}&deg;<br/>
				Set point heat: {%setPointHeat%}&deg;<br/>
				Set point cool: {%setPointCool%}&deg;'
			]]):template (tmpl_params)
		end
	end

	function lug_sPhoneRequest_lock(lul_device,lul_description,lul_js)
		local lul_Status = luup.variable_get("urn:micasaverde-com:serviceId:DoorLock1","Status",lul_device)
		local lul_PinCodes = luup.variable_get("urn:micasaverde-com:serviceId:DoorLock1","PinCodes",lul_device)

		local tmpl_params = {
			device = lul_device,
			description = lul_description,
			room = luup.devices[tonumber(lul_device)].room_num,
			time = os.clock(),
			status_lock = lul_Status=='1' and '_h' or '',
			status_unlock = lul_Status=='0' and '_h' or '',
			existing_codes = '',
		}

		if( lul_PinCodes~=nil and #lul_PinCodes>0 ) then
			local o = {'<table cellpadding="2" cellspacing="0">'}
			local codes = string.split(lul_PinCodes,"\t")
			for index,raw_code in pairs(codes) do
				local code_parts = string.split(raw_code,",")
				if(table.getn(code_parts)==5) then
					tmpl_params.part_1 = code_parts[1]
					tmpl_params.part_5 = code_parts[5]
					table.insert (o, ([[
						<tr>
							<td>{%part_5%}</td>
							<td><a href="data_request?id=lr_sPhone_action&room={%room%}&device={%device%}&service=urn:micasaverde-com:serviceId:DoorLock1&action=ClearPin&UserCode={%part_1%}&time={%time%}"><img src="{%sPh_LAYOUT_PFX%}/images/remove_deasupra.gif" border="0"></a></td>
						</tr>
						]]):template (tmpl_params))
				end
			end
			table.insert (o, '</table>')
			tmpl_params.existing_codes = table.concat (o)
		end


		if( lul_js == '1') then
			return ([[
				{%description%}<br>
				<img src="{%sPh_LAYOUT_PFX%}/images/spacer.gif" border="0" width="20" height="20" id="action_icon_{%device%}">
				<a href="javascript:void(0);" onClick="set_device_icon({%device%},1);send_command('data_request?id=lr_sPhone_action_js&room={%room%}&device={%device%}&service=urn:micasaverde-com:serviceId:DoorLock1&action=SetTarget&newTargetValue=0&time={%time%}',{%device%})"><img src="{%sPh_LAYOUT_PFX%}/buttons/unlock{%status_unlock%}.gif" alt="" border="0"/></a>
				<a href="javascript:void(0);" onClick="set_device_icon({%device%},1);send_command('data_request?id=lr_sPhone_action_js&room={%room%}&device={%device%}&service=urn:micasaverde-com:serviceId:DoorLock1&action=SetTarget&newTargetValue=1&time={%time%}',{%device%})"><img src="{%sPh_LAYOUT_PFX%}/buttons/lock{%status_lock%}.gif" alt="" border="0"/></a>
				<form action="data_request" method="get">
				<input type="hidden" name="id" value="lr_sPhone_action">
				<input type="hidden" name="room" value="{%room%}">
				<input type="hidden" name="device" value="{%device%}">
				<input type="hidden" name="service" value="urn:micasaverde-com:serviceId:DoorLock1">
				<input type="hidden" name="action" value="SetPin">
				<input type="hidden" name="time" value="{%time%}">
				<table cellpadding="2" cellspacing="0">
					<tr>
						<td>New code:</td>
						<td><input type="text" name="UserCodeName" id="UserCodeName_{%device%}" value="" size="8"></td>
					</tr>
					<tr>
						<td>PIN code:</td>
						<td><input type="text" name="newPin" id="newPin_{%device%}" value="" size="8"></td>
					</tr>
					<tr>
						<td></td>
						<td><img src="{%sPh_LAYOUT_PFX%}/images/set_deasupra.gif" border="0" onClick="set_device_icon({%device%},1);send_command('data_request?id=lr_sPhone_action_js&room={%room%}&device={%device%}&service=urn:micasaverde-com:serviceId:DoorLock1&action=SetPin&UserCodeName='+document.getElementById('UserCodeName_{%device%}').value+'&newPin='+document.getElementById('UserCodeName_{%device%}').value+'&time={%time%}',{%device%})"></td>
					</tr>
				</table>
				</form>
				{%existing_codes%}
			]]):template (tmpl_params)
		else
			return ([[
				{%lul_description%}<br>
				<a href="data_request?id=lr_sPhone_action&room={%room%}&device={%device%}&service=urn:micasaverde-com:serviceId:DoorLock1&action=SetTarget&newTargetValue=0&time={%time%}"><img src="{%sPh_LAYOUT_PFX%}/buttons/unlock{%status_unlock%}.gif" alt="" border="0"/></a>
				<a href="data_request?id=lr_sPhone_action&room={%room%}&device={%device%}&service=urn:micasaverde-com:serviceId:DoorLock1&action=SetTarget&newTargetValue=1&time={%time%}"><img src="{%sPh_LAYOUT_PFX%}/buttons/lock{%status%}.gif" alt="" border="0"/></a>
				<form action="data_request" method="get">
					<input type="hidden" name="id" value="lr_sPhone_action">
					<input type="hidden" name="room" value="{%room%}">
					<input type="hidden" name="device" value="{%device%}">
					<input type="hidden" name="service" value="urn:micasaverde-com:serviceId:DoorLock1">
					<input type="hidden" name="action" value="SetPin">
					<input type="hidden" name="time" value="{%time%}">
					<table cellpadding="2" cellspacing="0">
						<tr>
							<td>New code:</td>
							<td><input type="text" name="UserCodeName" value="" size="4"></td>
						</tr>
						<tr>
							<td>4 digit code:</td>
							<td><input type="text" name="newPin" value="" size="4"></td>
						</tr>
						<tr>
							<td></td>
							<td><input type="image" src="{%sPh_LAYOUT_PFX%}/images/set_deasupra.gif" border="0"></td>
						</tr>
					</table>
				</form>
				{%existing_codes%}
			]]):template (tmpl_params)
		end
	end

	function lug_sPhoneRequest_camimg(lul_request,lul_parameters,lul_outputformat)
		local lul_device = lul_parameters.device

		local tmpl_params = {
			header = html_header,
			footer = html_footer,
			device = lul_device,
			room = luup.devices[tonumber(lul_device)].room_num,
			time = os.clock(),
		}
		local lul_js = flag(lul_parameters.js)
		tmpl_params.js = lul_js
		g_is_remote = flag (lul_parameters.r)
		
		local streamingurl = luup.variable_get ('urn:micasaverde-com:serviceId:Camera1', 'DirectStreamingURL', lul_device)
		if streamingurl and g_is_remote=='1' then
			streamingurl = string.format('data_request?id=lu_camera_port&DeviceNum=%d', lul_device)
		end
		tmpl_params.url = streamingurl or ("data_request?id=cam_image&Device_Num={%device%}&room={%room%}&time={%time%}"):template(tmpl_params)
		

		if( lul_js=='1' ) then
			return ([[
				{%header%}
				<div id="toolbar" class="toolbar"> <a href="data_request?id=lr_sPhone_room&room={%room%}&time={%time%}"><img src="{%sPh_LAYOUT_PFX%}/images/backButton.gif" border="0"></a> </div>
				<div align="center">View camera <br/>
				<img src="{%url%}" id="view_{%device%}"><br>
				<img src="{%sPh_LAYOUT_PFX%}/images/spacer.gif" border="0" width="20" height="20" id="action_icon_{%device%}"><br>
				<a href="javascript:void(0)" onClick="sp_move_camera({%device%},'MoveUp');"><img src="{%sPh_LAYOUT_PFX%}/images/buupdeasupra.gif" border="0"></a>
				<a href="javascript:void(0)" onClick="sp_move_camera({%device%},'MoveDown');"><img src="{%sPh_LAYOUT_PFX%}/images/budowndeasupra.gif" border="0"></a>
				<a href="javascript:void(0)" onClick="sp_move_camera({%device%},'MoveLeft');"><img src="{%sPh_LAYOUT_PFX%}/images/buldeasupra.gif" border="0"></a>
				<a href="javascript:void(0)" onClick="sp_move_camera({%device%},'MoveRight');"><img src="{%sPh_LAYOUT_PFX%}/images/burdeasupra.gif" border="0"></a>
				<a href="javascript:void(0)" onClick="sp_move_camera({%device%},'ZoomIn');"><img src="{%sPh_LAYOUT_PFX%}/images/buplusdeasupra.gif" border="0"></a>
				<a href="javascript:void(0)" onClick="sp_move_camera({%device%},'ZoomOut');"><img src="{%sPh_LAYOUT_PFX%}/images/buminusdeasupra.gif" border="0"></a>
				<br><a href="data_request?id=lr_sPhone_camimg&device={%device%}&js={%js%}&time={%time%}&r={%g_is_remote%}">Refresh</a>
				{%footer%}
			]]):template (tmpl_params)
		else
			return ([[
				<div id="toolbar" class="toolbar"> <a href="data_request?id=lr_sPhone_room&room={%room%}&time={%time%}"><img src="{%sPh_LAYOUT_PFX%}/images/backButton.gif" border="0"></a> </div>
				<div align="center">View camera <br/>
				<img src="{%url%}"><br>
				<a href="data_request?id=lr_sPhone_action&room={%room%}&device={%device%}&service=urn:micasaverde-com:serviceId:PanTiltZoom1&action=MoveUp"><img src="{%sPh_LAYOUT_PFX%}/images/buupdeasupra.gif" border="0"></a>
				<a href="data_request?id=lr_sPhone_action&room={%room%}&device={%device%}&service=urn:micasaverde-com:serviceId:PanTiltZoom1&action=MoveDown"><img src="{%sPh_LAYOUT_PFX%}/images/budowndeasupra.gif" border="0"></a>
				<a href="data_request?id=lr_sPhone_action&room={%room%}&device={%device%}&service=urn:micasaverde-com:serviceId:PanTiltZoom1&action=MoveLeft"><img src="{%sPh_LAYOUT_PFX%}/images/buldeasupra.gif" border="0"></a>
				<a href="data_request?id=lr_sPhone_action&room={%room%}&device={%device%}&service=urn:micasaverde-com:serviceId:PanTiltZoom1&action=MoveRight"><img src="{%sPh_LAYOUT_PFX%}/images/burdeasupra.gif" border="0"></a>
				<a href="data_request?id=lr_sPhone_action&room={%room%}&device={%device%}&service=urn:micasaverde-com:serviceId:PanTiltZoom1&action=ZoomIn"><img src="{%sPh_LAYOUT_PFX%}/images/buplusdeasupra.gif" border="0"></a>
				<a href="data_request?id=lr_sPhone_action&room={%room%}&device={%device%}&service=urn:micasaverde-com:serviceId:PanTiltZoom1&action=ZoomOut"><img src="{%sPh_LAYOUT_PFX%}/images/buminusdeasupra.gif" border="0"></a>
				<br><a href="data_request?id=lr_sPhone_camimg&device={%device%}&time={%time%}&js={%js%}&r={%g_is_remote%}">Refresh</a>
			]]):template (tmpl_params)
		end

	end

	function lug_sPhoneRequest_room(lul_request,lul_parameters,lul_outputformat)
		local lul_room = lul_parameters.room
		local lul_js = flag(lul_parameters.js)
		g_is_remote = flag (lul_parameters.r)
-- 		if( lul_js==nil or tonumber(lul_js)==0 ) then
-- 			lul_js = 0;
-- 		end

		luup.log("lul_js = " .. tostring(lul_js))

		if( lul_room==nil or tonumber(lul_room)==0 ) then -- Room 0 means the main menu
			return lug_sPhoneRequest(lul_request,lul_parameters,lul_outputformat)
		end

		local tmpl_params = {
			room = lul_room,
			js = lul_js,
			time = os.clock(),
		}

		local lul_html = {html_header, ([[
			<div id="toolbar" class="toolbar"> <div class="b_left"><a href="data_request?id=lr_sPhone"><img src="{%sPh_LAYOUT_PFX%}/images/backButton.gif" border="0"></a></div>  <div align="right" class="b_right"><a href="data_request?id=lr_sPhone_room&room={%room%}&time={%time%}&js={%js%}&r={%g_is_remote%}"><img src="{%sPh_LAYOUT_PFX%}/images/refresh.gif" border="0"></a></div></div>
			<ul title="Room" selected="true">
		]]):template (tmpl_params)}

		local scene_grouphead_inserted = false
		for k,v in pairs(luup.scenes) do
			if( v.room_num==tonumber(lul_room) and v.hidden==false ) then
				if not scene_grouphead_inserted then
					table.insert (lul_html, '<li class="group">Scenes</li>')
				end
				tmpl_params.scene = k
				tmpl_params.remote = v.remote
				tmpl_params.page = v.page
				tmpl_params.description = v.description

				if(lul_js==0) then
					table.insert (lul_html, ([[
						<li class="bg">
							<a href="data_request?id=lr_sPhone_action&remote={%remote%}&page={%page%}&room={%room%}&device=0&service=urn:micasaverde-com:serviceId:HomeAutomationGateway1&action=RunScene&SceneNum={%scene%}&time={%time%}">
								<img src="{%sPh_LAYOUT_PFX%}/buttons/go.gif" alt="" width="36" height="36" border="0" align="absmiddle" class="icon"/>
							</a>
							{%description%}
						</li>
					]]):template (tmpl_params))
				else
					table.insert (lul_html, ([[
						<li class="bg">
							<img src="{%sPh_LAYOUT_PFX%}/images/spacer.gif" border="0" width="20" height="20" id="scene_action_icon_{%scene%}" style="vertical-align:middle">
							<a href="javascript:void(0)" onClick="set_scene_icon({%scene%},1);sp_run_scene('data_request?id=lr_sPhone_action_js&remote={%remote%}&page={%page%}&room={%room%}&device=0&service=urn:micasaverde-com:serviceId:HomeAutomationGateway1&action=RunScene&SceneNum={%scene%}&time={%time%}',{%scene%});">
								<img src="{%sPh_LAYOUT_PFX%}/buttons/go.gif" alt="" width="36" height="36" border="0" style="vertical-align:middle" class="icon"/>
							</a>
							{%description%}
						</li>
					]]):template (tmpl_params))

				end
			end
		end

		list_devices (lul_room, lul_html, lul_js)

		table.insert (lul_html, html_footer)

		return table.concat(lul_html),"text/html"
	end

	function string:split(delimiter)
	  local result = { }
	  local from  = 1
	  local delim_from, delim_to = string.find( self, delimiter, from  )
	  while delim_from do
		table.insert( result, string.sub( self, from , delim_from-1 ) )
		from  = delim_to + 1
		delim_from, delim_to = string.find( self, delimiter, from  )
	  end
	  table.insert( result, string.sub( self, from  ) )
	  return result
	end

	function lug_sPhoneRequest_action_js(lul_request,lul_parameters,lul_outputformat)
		local lul_room = lul_parameters.room
		local lul_device = lul_parameters.device
		local lul_action = lul_parameters.action
		local lul_service = lul_parameters.service
		if( lul_device==nil or lul_action==nil or lul_service==nil ) then
			luup.log("lug_sPhoneRequest_action: missing arguments")
			return 'ERROR: Missing arguments'
		end

		local lul_arguments = {}

		for k,v in pairs(lul_parameters) do
			if( k~="device" and k~="action" and k~="service" and k~="room" and k~="time" ) then
				lul_arguments[k]=v
			end

			luup.log("lug_sPhoneRequest_action: " .. tostring(k) .. "=" .. v)
		end

		for k,v in pairs(lul_arguments ) do
			luup.log("lug_sPhoneRequest_action: argument " .. tostring(k) .. "=" .. v)
		end

		local lul_resultcode,lul_resultstring,lul_job,lul_returnarguments = luup.call_action(lul_service,lul_action,lul_arguments,tonumber(lul_device))

		luup.log("lug_sPhoneRequest_action: device: " .. tostring(lul_device) .. " action: " .. tostring(lul_action) .. " service: " .. tostring(lul_service)  .. " returned: " .. tostring(lul_resultcode) .. " str " ..tostring(lul_resultstring) .. " job " .. tostring(lul_job))

		if( lul_resultcode~=0 ) then
			return 'ERROR: ' .. tostring(lul_resultcode) .. ': ' .. tostring(lul_resultstring)
		end
		luup.log("lul_resultcode: " .. lul_resultcode)
		luup.log("lul_resultstring: " .. lul_resultstring)
		if( lul_job==0 ) then
			return 'OK'
		end

		return 'Running: ' .. lul_job .. '|' .. lul_device
	end

	function lug_sPhoneRequest_job_status(lul_request,lul_parameters,lul_outputformat)
		local lul_device = lul_parameters["device"]
		local lul_room = lul_parameters["room"]
		local lul_job = lul_parameters["job"]

		local lul_job_status,lul_job_text = luup.job.status(lul_job,tonumber(lul_device))

		local lul_text = ""

		if( lul_job_status==nil ) then
			lul_text = 'ERROR: No information on command. Command history is only kept for 30 seconds.'
		elseif( lul_job_status==0 or lul_job_status==1 or lul_job_status==5 ) then
			lul_text = 'Running'
		elseif( lul_job_status==2 or lul_job_status==3 ) then
			lul_text = 'ERROR: Failed to run command'
		elseif( lul_job_status==4 ) then
			lul_text = 'OK'
		else
			lul_text = 'ERROR: Unknown status:' .. tostring(lul_job_status)
		end

		return lul_text
	end
end