//V3.01.A - http://www.openjs.com/scripts/jx/
jx = {
	//Create a xmlHttpRequest object - this is the constructor. 
	getHTTPObject : function() {
		var http = false;
		//Use IE's ActiveX items to load the file.
		if(typeof ActiveXObject != 'undefined') {
			try {http = new ActiveXObject("Msxml2.XMLHTTP");}
			catch (e) {
				try {http = new ActiveXObject("Microsoft.XMLHTTP");}
				catch (E) {http = false;}
			}
		//If ActiveX is not available, use the XMLHttpRequest of Firefox/Mozilla etc. to load the document.
		} else if (window.XMLHttpRequest) {
			try {http = new XMLHttpRequest();}
			catch (e) {http = false;}
		}
		return http;
	},
	// This function is called from the user's script. 
	//Arguments - 
	//	url	- The url of the serverside script that is to be called. Append all the arguments to 
	//			this url - eg. 'get_data.php?id=5&car=benz'
	//	callback - Function that must be called once the data is ready.
	//	format - The return type for this function. Could be 'xml','json' or 'text'. If it is json, 
	//			the string will be 'eval'ed before returning it. Default:'text'
	load : function (url,callback,format) {
		var http = this.init(); //The XMLHttpRequest object is recreated at every call - to defeat Cache problem in IE
		if(!http||!url) return;
		if (http.overrideMimeType) http.overrideMimeType('text/xml');

		if(!format) var format = "text";//Default return type is 'text'
		format = format.toLowerCase();
		
		//Kill the Cache problem in IE.
		var now = "uid=" + new Date().getTime();
		url += (url.indexOf("?")+1) ? "&" : "?";
		url += now;

		http.open("GET", url, true);

		http.onreadystatechange = function () {//Call a function when the state changes.
			if (http.readyState == 4) {//Ready State will be 4 when the document is loaded.
				if(http.status == 200) {
					var result = "";
					if(http.responseText) result = http.responseText;
					
					//If the return is in JSON format, eval the result before returning it.
					if(format.charAt(0) == "j") {
						//\n's in JSON string, when evaluated will create errors in IE
						result = result.replace(/[\n\r]/g,"");
						result = eval('('+result+')'); 
					}
	
					//Give the data to the callback function.
					if(callback) callback(result);
				} else { //An error occured
					if(error) error(http.status);
				}
			}
		}
		http.send(null);
	},
	init : function() {return this.getHTTPObject();},
	error: function(httpStatus) {alert('HTTP error: '+httpStatus)}
}

var aryClassElements = new Array();

function js_prepare_urls(){
    aryClassElements.length = 0;
    getElementsByClassName( 'pic', document.body );
    for ( var i = 0; i < aryClassElements.length; i++ ) {
        aryClassElements[i].href = aryClassElements[i].href+'&js=1';
    }	
}

function getElementsByClassName( strClassName, obj ) {
    if ( obj.className == strClassName ) {
        aryClassElements[aryClassElements.length] = obj;
    }
    for ( var i = 0; i < obj.childNodes.length; i++ )
        getElementsByClassName( strClassName, obj.childNodes[i] );
}

function send_command(command,device){
	jx.load(command,
	function(data){
		//alert(data)
		if(data.substr(0,7)=='Running'){
			var resp=data.substr(8,data.length);
			var parts=resp.split('|');
			if(parts.length!=2){
				//alert(data);
				set_device_icon(device,2);
				return;
			}
			// start check the job every 1 s until job is done or 5s have passed
			setTimeout("get_job_status("+parts[1]+","+parts[0]+",1)",1000);
			
			return false;
		}
		if(data.substr(0,5)=='ERROR'){
			//alert(data);
			set_device_icon(device,2);
			
			return false;
		}
		
		if(data=='OK'){
			//alert(data);
			set_device_icon(device,3);
			self.location.reload();
			
			return false;
		}
		// none of the above, show output
		//alert('End: '+data);
	},
	'text/html');
}

function get_job_status(device,job,retry){
	var currentTime = new Date();
	var ctime = currentTime.getTime();
	
	var command='/port_49451/data_request?id=lr_sPhone_job_status&device='+device+'&job='+job+'&ctime='+ctime;
	jx.load(command,
	function(data){
		//alert(data);
		if(data=='OK'){
			// job executed, callback function?
			set_device_icon(device,3);
			self.location.reload();
			return;
		}
		if(data.substr(0,5)=='ERROR'){
			//alert(data);
			set_device_icon(device,2);
			
			return;
		}
		if(data=='Running'){
			if(retry==20){
				//alert("Command failed");
				set_device_icon(device,2);
			}else{
				retry++;
				setTimeout("get_job_status("+device+","+job+","+retry+")",1000);
			}
			return;
		}
		// any other status
		//alert(data);
		set_device_icon(device,3);
		location.reload();
	},
	'text');	
}

function set_device_icon(device,mode){
	var icon='/cmh/images/spacer.gif';
	if(mode==1){
		// waiting
		icon='/cmh/iphone_file/buttons/wait.gif';
	}
	if(mode==2){
		// error
		icon='/cmh/iphone_file/buttons/eror.gif';
	}
	if(mode==3){
		// error
		icon='/cmh/iphone_file/buttons/ok.gif';
	}	
	
	if(document.getElementById('action_icon_'+device)){
		document.getElementById('action_icon_'+device).src=icon;
	}
	
	// after 10s reset the icon
	if(mode && mode!=1){
		setTimeout("set_device_icon("+device+")",5000);	
	}
}

function sp_move_camera(deviceID,action){
	set_device_icon(deviceID,1);
	var url='data_request?id=lr_sPhone_action_js&device=' + deviceID + '&service=urn:micasaverde-com:serviceId:PanTiltZoom1&action='+action;
	jx.load(url,
	function(data){
		//alert(data);
		if(data=='OK'){
			// job executed, callback function?
			set_device_icon(deviceID,3);
			var currentTime = new Date();
			var ctime = currentTime.getTime();
			document.getElementById('view_'+deviceID).src='data_request?id=cam_image&Device_Num=' +deviceID+ '&time=' +ctime;
			return;
		}
		if(data.substr(0,5)=='ERROR'){
			//alert(data);
			set_device_icon(deviceID,2);
			
			return;
		}
		// any other status
		//alert(data);
		set_device_icon(deviceID,2);
	},
	'text');	
}

function sp_run_scene(command,sceneID){
	jx.load(command,
	function(data){
		//alert(data)
		if(data.substr(0,5)=='ERROR'){
			//alert(data);
			set_scene_icon(sceneID,2);
			
			return false;
		}
		
		if(data=='OK'){
			//alert(data);
			set_scene_icon(sceneID,3);
			setTimeout("self.location.reload()",2000);	
			
			return false;
		}
	},
	'text/html');
}

function set_scene_icon(sceneID,mode){
	var icon='/cmh/images/spacer.gif';
	if(mode==1){
		// waiting
		icon='/cmh/iphone_file/buttons/wait.gif';
	}
	if(mode==2){
		// error
		icon='/cmh/iphone_file/buttons/eror.gif';
	}
	if(mode==3){
		// error
		icon='/cmh/iphone_file/buttons/ok.gif';
	}	
	
	if(document.getElementById('scene_action_icon_'+sceneID)){
		document.getElementById('scene_action_icon_'+sceneID).src=icon;
	}
	
	// after 10s reset the icon
	if(mode && mode!=1){
		setTimeout("set_scene_icon("+sceneID+")",5000);	
	}
}